/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "appfilemenu.h"
#include "appwindow.h"
#include "dialogs.h"
#include "i18n.h"
#include <stdio.h>

void
AppFileMenu::new_()
{
  NewSetDialog *newset_dialog;
  
  newset_dialog = SigC::manage(new NewSetDialog(window, orderedsets));
  newset_dialog->exec();
}

void
AppFileMenu::open()
{
  OpenFileDialog *open_dialog;
  
  open_dialog = SigC::manage(new OpenFileDialog(window, orderedsets));
  open_dialog->exec();
}

AppFileMenu::AppFileMenu(AppWindow *win, OrderedSets *oss)
{
  orderedsets = oss;
  window = win;
  // tearoff
  items().push_back(Gtk::Menu_Helpers::TearoffMenuElem()); 
  // new
  items().push_back(Gtk::Menu_Helpers::MenuElem
		    (_("New..."), Gtk::Menu_Helpers::CTL|'N',
		     SigC::slot(*this, &AppFileMenu::new_)));
  // open
  items().push_back(Gtk::Menu_Helpers::MenuElem
		    (_("Open..."), Gtk::Menu_Helpers::CTL|'O',
		     SigC::slot(*this, &AppFileMenu::open)));
  // separator
  items().push_back(Gtk::Menu_Helpers::SeparatorElem()); 
  // quit
  items().push_back(Gtk::Menu_Helpers::MenuElem
		    (_("Quit"), Gtk::Menu_Helpers::CTL|'Q',
		     SigC::slot(*window, &AppWindow::close)));
  show();
}
