/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the application window

#ifndef __APPWINDOW_H__
#define __APPWINDOW_H__

#include "orderedsets.h"
#include <gtk--/window.h>
#include <gtk--/main.h>

class AppButtons;
class AboutDialog;

class AppWindow : public Gtk::Window {
 protected:
  OrderedSets *orderedsets;
  OrderedSet *copy_orderedset;
  AppButtons *buttons;
  string title;
  AboutDialog *about_dialog;
  // on window close
  bool reallyClose();
  // on window manager close
  gint delete_event_impl(GdkEventAny* e);
  void destroy_handler() { Gtk::Main::quit(); }
  void help();
  void about();
 public:
  AppWindow(OrderedSets *oss);
  ~AppWindow();
  AppButtons *getButtons() { return buttons; }
  OrderedSet *getCopyOrderedSet() { return copy_orderedset; }
  void close();
};

#endif
