/* LatVis
 * Copyright (C) 2002 Jan Outrata <outrataj@phoenix.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the generated diagram using the level method

#ifndef __LEVELDIAGRAM_H__
#define __LEVELDIAGRAM_H__

#include "diagram.h"

class LevelDiagram : public Diagram {
 public:
  struct generationParams_t : public Diagram::generationParams_t {
    bool from_minimal;
  };
 protected:
  typedef unsigned long eval_t;
  struct Eval {
    ElementId element;
    eval_t eval;
    // comparison function for STL
    bool
    operator <(const Eval &e) const
    {
      if (eval < e.eval) return true;
      if (e.eval < eval) return false;
      return (element < e.element);
    }
  };
  OrderData *data;
  set<Vertex_e> verteces;
  generationParams_t *generationParams;
 public:
  LevelDiagram(OrderData *d) { if (d) data = d; }
  ~LevelDiagram() {}
  void generateDiagram(Diagram::generationParams_t *params);
  void getDiagram(set<Vertex_e> &s) { s = verteces; }
};

#endif
